<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
require_once("./dhtmlx/codebase/connector/db_phpci.php");
require_once("./dhtmlx/codebase/connector/grid_connector.php");
require_once("./dhtmlx/codebase/connector/form_connector.php");

DataProcessor::$action_param ="dhx_editor_status";
class Home extends CI_Controller {
    function __construct(){
        parent::__construct();
        //if($this->session->userdata('perfil') == FALSE || $this->session->userdata('perfil') != 'Administrador'){
        if($this->session->userdata('is_loggedin') != TRUE){
            redirect(base_url().'login');
        }//Segurizar aplicación

        $this->load->database();
        $this->load->model('inout_model');
        $this->load->model('personal_model');
        $this->output->enable_profiler(FALSE);
    }
    function index(){
        $data['csrf_hash']          = $this->security->get_csrf_hash();
        $data['csrf_token_name']    = $this->security->get_csrf_token_name();
        $data['titulo']             = 'Bienvenido '.$this->session->userdata('username');
        $this->load->view('headers', $data);
    }
    function gridConsultarMes(){
        function formatting($row){
            $data = $row->get_value('image');
            $row->set_value('image', base64_encode($data));
        }
        $connector = new GridConnector($this->db, 'phpCI');
        $connector->event->attach('beforeRender', 'formatting');
        $connector->configure(
            'tbl_inout',
            'id',
            'id_personal, app_datetime, image, is_in, is_out');
        $connector->enable_log(FCPATH.'assets/uploaded/conConsultarMes.txt', TRUE);
        $connector->useModel($this->inout_model);
        $connector->render();
    }
    function gridPersonalData(){
        function custom_sort($sorted_by){
            //SORT BY some_field ASC
            if (!sizeof($sorted_by->rules))
                $sorted_by->add('apellido', 'ASC');
                $sorted_by->add('nombre', 'ASC');
        }
        function custom_filter($filter_by){
            //WHERE some_field LIKE 'value'
            if (!sizeof($filter_by->rules)){
                $filter_by->add('id_personal','value','LIKE');
            }
        }
        $connector = new GridConnector($this->db, 'phpCI');
        $connector->event->attach('beforeSort', 'custom_sort');
        //$connector->event->attach('beforeFilter','custom_filter');
        $connector->configure(
            'tbl_personal',
            'id',
            'id_personal, apellido, nombre');
        $connector->render();
    }
    function frmEmpleadoData(){
        function formatting($row){
            //set row color
            //$row->set_row_color($row->get_value("color"));
            $data = $row->get_value('image');
            $row->set_value('image', base64_encode($data));
            //save in userdata
            //$row->set_userdata("some_data",$data);
        }
        $connector = new FormConnector($this->db, 'phpCI');
        $connector->event->attach('beforeRender', 'formatting');
        $connector->configure(
            'tbl_personal',
            'id',
            'id_personal,
            apellido,
            nombre,
            image,
            hora_ingreso,
            horas_x_dia,
            direccion,
            telefono,
            celular,
            email,
            observaciones,
            is_active');
        $connector->enable_log(FCPATH.'assets/uploaded/conForm.txt', true);
        $connector->useModel($this->personal_model);
        $connector->render();
    }
    function cargar_gridPersonal(){
        $this->home_model->gridPersonalData();
    }
    function guardar_frmEmpleado(){
        $this->home_model->frmEmpleadoData();
    }
    function uploadAction(){
        $config['upload_path'] = FCPATH.'assets/uploaded/';
        $config['allowed_types'] = 'gif|jpg|png';
        $config['overwrite'] = true;
        $config['max_size']	= '100';
        $config['max_width'] = '640';
        $config['max_height'] = '480';

        $field_name = 'file';

        $this->load->library('upload',$config);

        if ($this->input->get('mode') == "html5" || $this->input->get('mode') == "flash"){
            $this->upload->do_upload($field_name);
            $f_name = $this->upload->data();
            $filename = $f_name['file_name'];
            $this->output
                ->set_content_type('text/json')
                ->set_output(json_encode(array(
                "state" => true,    // saved or not saved
                "name"  => $filename,   // server-name
                "extra" => array(   // extra info, optional
                    "info"  => "just a way to send some extra data",
                    "param" => "some value here"
                )
            )));
        }
        if ($this->input->get('mode') == 'html4'){
            $this->output->set_header('Content-Type: text/html');
            if ($this->input->get('action') == 'cancel') {
                $this->output
                    ->set_content_type('text/json')
                    ->set_output(json_encode(array(
                        "state" => 'cancelled'
                    )));
            } else {
                $this->upload->do_upload($field_name);
                $f_name = $this->upload->data();
                $filename = $f_name['file_name'];
                $filename_size = $f_name['file_size'];
                $this->output
                    ->set_content_type('text/json')
                    ->set_output(json_encode(array(
                        "state" => true,    // saved or not saved
                        "name"  => $filename,   // server-name
                        "size"  => $filename_size,
                        "extra" => array(   // extra info, optional
                            "info"  => "just a way to send some extra data",
                            "param" => "some value here"
                        )
                    )));
            }
        }
    }
}