<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Inout_model extends CI_Model {
    private $tabla = 'tbl_inout';
    var $id_personal;
    var $app_datetime;
    var $srv_datetime;
    var $file_size;
    var $image;
    var $observaciones;
    var $is_in;
    var $is_out;
    var $is_enabled;
    var $is_active;

    function __construct(){
        parent::__construct();
    }
    //returns an array with data
    function getA($request){
        $query = $this->db->get($this->tabla);
        return $query->result_array();
    }
    function get($request){
        $wheres = array();
        foreach ($request->get_filters() as $where)
        {
            $wheres[$where['name']] = $where['value'];
        }
        $this->db
            ->select()
            ->from($this->tabla)
            ->like('app_datetime', $wheres['app_datetime'], 'after')
            ->where('id_personal', $wheres['id_personal']);
        $query = $this->db->get();
        return $query->result_array();
    }
    //the function takes values of the row data
    protected function get_values($action){
        $file = FCPATH.'assets/uploaded/'.$action->get_value('uploadFoto_s_0');

        $this->id_personal   = $action->get_value('id_personal');
        $this->apellido      = $action->get_value('apellido');
        $this->nombre        = $action->get_value('nombre');
        $this->file_size     = filesize($file);
        $this->image         = read_file($file);
        $this->created_at    = date('Y-m-d H:i:s');
        $this->updated_at    = date('Y-m-d H:i:s');
        $this->hora_ingreso  = $action->get_value('hora_ingreso');
        $this->horas_x_dia   = $action->get_value('horas_x_dia');
        $this->direccion     = $action->get_value('direccion');
        $this->telefono      = $action->get_value('telefono');
        $this->celular       = $action->get_value('celular');
        $this->email         = $action->get_value('email');
        $this->observaciones = $action->get_value('observaciones');
        $this->is_active     = $action->get_value('is_active');
    }
    //inserts a new empleado
    function insert($action){
        $this->get_values($action);

        if ($this->validate($action)){
            $this->db->insert($this->tabla, $this);
            $action->success($this->db->insert_id());
        }
    }
    //updates an event
    function update($action){
        $this->get_values($action);
        $this->db->update($this->tabla, $this, array('id' => $action->get_id()));
        $action->success();
        /*if ($this->validate($action)){
            $this->db->update(
                $this->tabla,
                $this,
                array("event_id" => $action->get_id())
            );
            $action->success();
        }*/
    }
    // validates an event before saving
    function validate($action){
        $this->db->select('id_personal');
        $this->db->from($this->tabla);
        $this->db->where('id_personal', $this->id_personal);
        $query = $this->db->get();

        if ($query->num_rows() > 0){
            $action->invalid();
            $action->set_response_attribute(
                'details',
                '¡Legajo existente - Ingrese un legajo distinto!'
            );
            return false;
        }
        return true;
    }
    //deletes an event
    function delete($action){
        $this->db->delete($this->tabla, array('event_id' => $action->get_id()));
        $action->success();
    }
}