<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Personal_model extends CI_Model {
    private $tabla = 'tbl_personal';
    var $id_personal;
    var $apellido;
    var $nombre;
    var $file_size;
    var $image;
    var $created_at;
    var $updated_at;
    var $hora_ingreso;
    var $horas_x_dia;
    var $direccion;
    var $telefono;
    var $celular;
    var $email;
    var $observaciones;
    var $is_active;

    function __construct(){
        parent::__construct();
    }
    //returns an array with data
    function get($request){
        $where = $request->get_filters();
        //$query = $this->db->get($this->tabla);
        $query = $this->db->get_where($this->tabla, array('id' => $where[0]['value']));
        foreach ($query->result_array() as $row)
        {
            $result = array(
                '0' => $res = array(
                        'id'            => $row['id'],
                        'id_personal'   => $row['id_personal'],
                        'apellido'      => $row['apellido'],
                        'nombre'        => $row['nombre'],
                        'image'         => $row['image'],
                        'hora_ingreso'  => $row['hora_ingreso'],
                        'horas_x_dia'   => $row['horas_x_dia'],
                        'direccion'     => $row['direccion'],
                        'telefono'      => $row['telefono'],
                        'celular'       => $row['celular'],
                        'email'         => $row['email'],
                        'observaciones' => $row['observaciones'],
                        'is_active'     => $row['is_active']
                    )
            );
        }
        //return $query->result_array();
        return $result;
    }
    //the function takes values of the row data
    protected function get_values($action){
        $file = FCPATH.'assets/uploaded/'.$action->get_value('uploadFoto_s_0');

        $this->id_personal   = $action->get_value('id_personal');
        $this->apellido      = $action->get_value('apellido');
        $this->nombre        = $action->get_value('nombre');
        $this->file_size     = filesize($file);
        $this->image         = read_file($file);
        $this->created_at    = date('Y-m-d H:i:s');
        $this->updated_at    = date('Y-m-d H:i:s');
        $this->hora_ingreso  = $action->get_value('hora_ingreso');
        $this->horas_x_dia   = $action->get_value('horas_x_dia');
        $this->direccion     = $action->get_value('direccion');
        $this->telefono      = $action->get_value('telefono');
        $this->celular       = $action->get_value('celular');
        $this->email         = $action->get_value('email');
        $this->observaciones = $action->get_value('observaciones');
        $this->is_active     = $action->get_value('is_active');
    }
    //inserts a new empleado
    function insert($action){
        $this->get_values($action);

        if ($this->validate($action)){
            $this->db->insert($this->tabla, $this);
            $action->success($this->db->insert_id());
        }
    }
    //updates an event
    function update($action){
        $this->get_values($action);
        $this->db->update($this->tabla, $this, array('id' => $action->get_id()));
        $action->success();
        /*if ($this->validate($action)){
            $this->db->update(
                $this->tabla,
                $this,
                array("event_id" => $action->get_id())
            );
            $action->success();
        }*/
    }
    // validates an event before saving
    function validate($action){
        $this->db->select('id_personal');
        $this->db->from($this->tabla);
        $this->db->where('id_personal', $this->id_personal);
        $query = $this->db->get();

        if ($query->num_rows() > 0){
            $action->invalid();
            $action->set_response_attribute(
                'details',
                '¡Legajo existente - Ingrese un legajo distinto!'
            );
            return false;
        }
        return true;
    }
    //deletes an event
    function delete($action){
        $this->db->delete($this->tabla, array('event_id' => $action->get_id()));
        $action->success();
    }
}